#pragma once


#include <winusb.h>

#define BULKUSB_MAX_TRANSFER_SIZE   (16*1024)
typedef struct 
{
	HANDLE hDeviceHandle ;
	WINUSB_INTERFACE_HANDLE winUSBHandle;
	UCHAR deviceSpeed;
	UCHAR bulkInPipe;
	UCHAR bulkOutPipe;
	UCHAR interruptPipe;

}USBDEVINFO;

class CAdcBulkUsb
{
public:
	CAdcBulkUsb(void);
	~CAdcBulkUsb(void);
private:
	USBDEVINFO m_UsbDevInfo;

	//HANDLE m_hDevice;
public:
	BOOL Open(LPGUID  pGuid ,int DeviceNum = 0);
	
	BOOL CancelRead();
	BOOL CancelWrite();
	void Close();
	BOOL Read(LPVOID lpBuffer, DWORD nNumberOfBytesToRead, LPDWORD lpNumberOfBytesRead,DWORD dwMilliseconds=-1);
	BOOL Write(LPCVOID lpBuffer, DWORD nNumberOfBytesToWrite, LPDWORD lpNumberOfBytesWritten,DWORD dwMilliseconds=-1);

	char m_completeDeviceName[MAX_PATH];
};
