#include "sdk.h"

extern void evmboardinit();

/*
	debugstring, debugpritnf output channel can be changed using the set_debug_channel.
	ex)
	       set_debug_channel(0);
	       uart_config(0, 115200, DATABITS_8, STOPBITS_1, UART_PARNONE);	
*/

int main()
{
	evmboardinit();
	uart_config(5, 115200, DATABITS_8, STOPBITS_1, UART_PARNONE);
	debugstring("================================================\r\n");  
	debugprintf("adLuna UART Rx/Tx. System Clock(%dMhz)\r\n", get_ahb_clock() / 1000000);
	debugstring("================================================\r\n");
	
	// #define UART_SINGLE_CHAR
	
	while(1)
	{		
#ifdef UART_SINGLE_CHAR
		char ch;
		
		if(TRUE == uart_getch(5,&ch))
		{
			uart_putstring(5,"\r\nRx_Data:");
			uart_putch(5,ch);
		}
#else
		char rx_data[1024];
		char rx_len;
	
		rx_len = uart_getdata(5,rx_data,1024);
		if(rx_len != 0)
		{
			uart_putstring(5,"\r\nRx_Data:");			
			uart_putdata(5,rx_data,rx_len);
		}
#endif
	}
	
	
	while(1);
	return 0;
}