#include "sdk.h"

extern void evmboardinit();

int main()
{
	evmboardinit();
	uart_config(5, 115200, DATABITS_8, STOPBITS_1, UART_PARNONE);
	debugstring("================================================\r\n");  
	debugprintf("adLuna Serial Flash. System Clock(%dMhz)\r\n", get_ahb_clock() / 1000000);
	debugstring("================================================\r\n");

	U8 buf[16];
	U8 buf2[16];
	
	int i = 0;	
	
	for(i=0;i<16;i++)
	{
		buf[i] = i;
		buf2[i] = 0;
	}
	
	sflash_erase_sector(0, 127, 1);  // 0x7F000
	sflash_write(0x7F000, buf, 16);		
	sflash_read(0x7F000, buf2, 16);		

	printmem(buf2,16);
	
	while(1);
	return 0;
}
