#include "sdk.h"
void fs_enable_support_interrupt(int intnum, BOOL b)
{

}

FRESULT f_open(
	FIL *fp,			/* Pointer to the blank file object */
	void *path,	/* Pointer to the file name */
	U32 size
)
{
	fp->fs = path;
	fp->fptr = 0;
	fp->fsize = size;
	return FR_OK;
}

FRESULT f_read(
	FIL *fp, 		/* Pointer to the file object */
	void *buff,		/* Pointer to data buffer */
	U32 btr,		/* Number of bytes to read */
	U32 *br		/* Pointer to number of bytes read */
)
{
	if ((fp->fsize - fp->fptr) < btr)
		btr = fp->fsize - fp->fptr;
	btr = sflash_read(((U32)fp->fs)+fp->fptr, buff, btr);
	fp->fptr += btr;
	*br = btr;
	return FR_OK;
}

FRESULT f_lseek(
	FIL *fp,		/* Pointer to the file object */
	U32 ofs		/* File pointer from top of file */
)
{
	if (fp->fsize < ofs)
		return -1;
	fp->fptr = ofs;
	return FR_OK;
}

FRESULT f_close(
	FIL *fp		/* Pointer to the file object to be closed */
)
{
	return FR_OK;
}
